<template>
    <div
        v-if="shop"
        class="page-container"
    >
        <div class="video-button-container">
            <div
                v-if="balance && isWix && showEmailPlan_B"
                class="info-block__container"
            >
                <div class="info-block">
                    <div class="d-flex align-items-center">
                        <div class="info-block__text">
                            Email sent:
                        </div>
                        <div class="info-block__count">
                            {{ balance.emailSent }}/{{ balance.emailCount }}
                        </div>
                    </div>
                    <b-button
                        class="btn info-block__btn"
                        variant="primary"
                        @click="showModalAddEmailCredits = true"
                    >
                        Add email credits
                    </b-button> 
                </div>
            </div>
            <VideoButton :source="'https://carti.crisp.help/en/article/enable-email-cart-abandonment-automation-1oxiee1/reader'" />
        </div>
        <div class="row">
            <EmailAbandonedCard
                v-for="(card, index) in abandonedCards"
                :key="index"
                class="col-lg-4"
                :cart-data="card"
                :loader="loading"
            />
        </div>
        <div v-if="data">
            <EmailAbandonedTable
                :data="data"
                @freshData="freshData"
            />
            <div class="add-reminder-container">
                <div>
                    <b-btn
                        class="btn blue-btn"
                        @click="createAbandonedCart"
                    >
                        Add Reminder
                    </b-btn>
                </div>
            </div>
        </div>
        <AddEmailCredits
            :show="showModalAddEmailCredits"
            @close="showModalAddEmailCredits = false"
            @submited="showModalAddEmailCredits = false, updBalance()"
        />
    </div>
</template>

<script>
import EmailAbandonedCard from "@/components/email/abandoned-cards/EmailCard";
import EmailAbandonedTable from "@/components/email/abandoned-cards/EmailAbandonedTable";
import VideoButton from "@/components/header/VideoButton";
import carts from "@/mixins/email/abandoned-carts.service";
import currencies from "@/data/currencies.json";
import shop from '@/mixins/shop.service';
import AddEmailCredits from '@/components/email/AddEmailCredits'
import abTesting from '@/mixins/ab-testing'

export default {
    name: "EmailAbandonedCards",
    components: {VideoButton, EmailAbandonedTable, EmailAbandonedCard, AddEmailCredits},
    mixins: [carts, shop, abTesting],
    data: () => ({
        data: null,
        currencies: currencies,
        shop: null,
        balance: null,
        showModalAddEmailCredits: false,
        showEmailPlan_B: false,
        abandonedCards: [
            {
                title: 'Revenue Recovered',
                icon: 'fa fa-window-maximize',
                salesCount: '0',
                salesTitle: 'Sales'
            },
            {
                title: 'Abandoned Carts',
                icon: 'fa fa-users',
                salesCount: '0',
                salesTitle: 'Quantity'
            },
            {
                title: 'Orders Recovered',
                icon: 'fa fa-cube',
                salesCount: '0',
                salesTitle: 'Quantity'
            }
        ],
        loading: true,
    }),
    computed: {
        getCurrencySign() {
            if (!this.currencies)
                return {
                    symbol: this.shop.payment_currency
                };
            return this.currencies[this.shop.payment_currency];
        },
        isWix() {
            return this.$cookies.get('platform') == 'wix'
        }
    },
    async created() {
        this.loadShop()
        this.startABTesting()
        if(this.isWix) this.updBalance()
    },
    mounted() {
        this.freshData()
    },
    methods: {
        async updBalance() {
            this.balance = await this.getBalance()
        },
        async loadShop() {
            this.shop = await this.getShop()
        },
        async freshData() {
            this.data = null
            const request = await this.getAbandonedCarts().catch((error) => {
                console.log(error)
            })
            this.data = request.data;
            this.abandonedCards = [
                {
                    title: 'Revenue Recovered',
                    icon: 'fa fa-window-maximize',
                    salesCount: this.getCurrencySign.symbol_native + this.data.total_revenue,
                    salesTitle: 'Sales'
                },
                {
                    title: 'Abandoned Carts',
                    icon: 'fa fa-users',
                    salesCount: this.data.total_carts,
                    salesTitle: 'Quantity'
                },
                {
                    title: 'Orders Recovered',
                    icon: 'fa fa-cube',
                    salesCount: this.data.total_orders,
                    salesTitle: 'Quantity'
                }
            ]
            this.loading = false
        },
        async createAbandonedCart() {
            await this.createCart().catch((error) => {
                console.log(error)
            });
        }
    }
}
</script>

<style scoped>


</style>
